###############################################################################
#  @copyright(disclaimer)
#  IBM Enterprise Information Portal for Multiplatforms V7.1  (program number  5697-G29)
#  (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
#  IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03)
#  (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved.
#
#  US Government Users Restricted Rights
#
#  Use, duplication or disclosure restricted by GSA ADP Schedule
#  Contract with IBM Corp.  Licensed Materials - Property of IBM
# 
#  DISCLAIMER OF WARRANTIES :
#  Permission is granted to copy and modify this code, and to
#  distribute modified versions provided that both the copyright
#  notice and this permission notice appear in all copies and modified
#  versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS
#  ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM
#  WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE
#  OF THE CODE.
#                                                                
#  @endCopyright
###############################################################################
# makefile for both AIX and NT to build beans' samples package
#
# 05/12/1999/mimivo
#

JC	= javac 

JSRCS	=					\
	DemoConnect.java 			\
	DemoConnectUsingEvent.java 		\
	DemoConnectWithSchema.java 		\
	DemoDataMgt.java 			\
	DemoDriver2WithUI.java 			\
	DemoDriver3WithUI.java 			\
	DemoExceptionHandler.java 		\
	DemoItemAttr.java 			\
	DemoQueryExpr.java 			\
	DemoSchema.java 			\
	DemoSchemaWithUI.java 			\
	DemoSimpleAppl.java			\
	DemoSTCriteria.java 			\
	DemoSTQueryWithUI.java 			\
	DemoTraceLog.java 			\
	ItemRequestEvent.java 			\
	ItemRequestListener.java 		\
	SampleFocusAdapter.java 		\
	SampleGuiAttrEditor.java 		\
	SampleGuiAttrEditorBeanInfo.java 	\
	SampleGuiLogon.java 			\
	SampleGuiLogonBeanInfo.java 		\
	SampleGuiResults.java 			\
	SampleGuiResultsBeanInfo.java 		\
	SampleGuiSchema.java 			\
	SampleGuiSchemaBeanInfo.java 		\
	SampleGuiTemplate.java 			\
	SampleGuiTemplateBeanInfo.java 		\
	TemplateChangeEvent.java 		\
	TemplateChangeListener.java 		\
	UtilPersistent.java 			\
	UtilSimpleUI.java 			\
	UtilTableModel.java 

JOBJS =	$(JSRCS:.java=.class)

base:	$(JOBJS) 

all:	cleanall base jarall

javacall: 
	javac $(JSRCS)

jarall:
#	jar cfm cmbdemo.jar cmbvcafe.mft Sample*.class Util*.class Item*.class TemplateChange*.class
	jar cfm cmbvcafe.jar cmbvcafe.mft *.class *.gif

cleanall:
	erase *.class

DemoConnect.class:			DemoConnect.java
	$(JC) $?

DemoConnectUsingEvent.class:		DemoConnectUsingEvent.java
	$(JC) $?

DemoConnectWithSchema.class:		DemoConnectWithSchema.java
	$(JC) $?

DemoDataMgt.class:			DemoDataMgt.java
	$(JC) $?

DemoDriver2WithUI.class:		DemoDriver2WithUI.java
	$(JC) $?

DemoDriver3WithUI.class:		DemoDriver3WithUI.java
	$(JC) $?

DemoExceptionHandler.class:		DemoExceptionHandler.java
	$(JC) $?

DemoItemAttr.class:			DemoItemAttr.java
	$(JC) $?

DemoQueryExpr.class:			DemoQueryExpr.java
	$(JC) $?

DemoSchema.class:			DemoSchema.java
	$(JC) $?

DemoSchemaWithUI.class:			DemoSchemaWithUI.java
	$(JC) $?

DemoSimpleAppl.class:			DemoSimpleAppl.java
	$(JC) $?

DemoSTCriteria.class:			DemoSTCriteria.java
	$(JC) $?

DemoSTQueryWithUI.class:		DemoSTQueryWithUI.java
	$(JC) $?

DemoTraceLog.class:			DemoTraceLog.java
	$(JC) $?

ItemRequestEvent.class:			ItemRequestEvent.java
	$(JC) $?

ItemRequestListener.class:		ItemRequestListener.java
	$(JC) $?

SampleFocusAdapter.class:		SampleFocusAdapter.java
	$(JC) $?

SampleGuiAttrEditor.class:		SampleGuiAttrEditor.java
	$(JC) $?

SampleGuiAttrEditorBeanInfo.class:	SampleGuiAttrEditorBeanInfo.java
	$(JC) $?

SampleGuiLogon.class:			SampleGuiLogon.java
	$(JC) $?

SampleGuiLogonBeanInfo.class:		SampleGuiLogonBeanInfo.java
	$(JC) $?

SampleGuiResults.class:			SampleGuiResults.java
	$(JC) $?

SampleGuiResultsBeanInfo.class:		SampleGuiResultsBeanInfo.java
	$(JC) $?

SampleGuiSchema.class:			SampleGuiSchema.java
	$(JC) $?

SampleGuiSchemaBeanInfo.class:		SampleGuiSchemaBeanInfo.java
	$(JC) $?

SampleGuiTemplate.class:		SampleGuiTemplate.java
	$(JC) $?

SampleGuiTemplateBeanInfo.class:	SampleGuiTemplateBeanInfo.java
	$(JC) $?

TemplateChangeEvent.class:		TemplateChangeEvent.java
	$(JC) $?

TemplateChangeListener.class:		TemplateChangeListener.java
	$(JC) $?

UtilPersistent.class:			UtilPersistent.java
	$(JC) $?

UtilSimpleUI.class:			UtilSimpleUI.java
	$(JC) $?

UtilTableModel.class:			UtilTableModel.java
	$(JC) $?
