/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TDatastorePoolDD.java
 * Description    : test DKDatastorePool for datastore connection pool
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;
import java.lang.reflect.*;

// TDatastorePoolDD class
public class TDatastorePoolDD implements DKConstantDD {

  public static String Me = new String("TListSubEntitiesDD");
  // Main method
  public static void main(String argv[]){
    
      //*** for input parameters
      String libSrv = new String(""),   // library server
             userid = new String(""),   // userid 
  	     pw = new String("");       // pw
      String fullClassName = "com.ibm.mm.sdk.server.DKDatastoreDD";

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TDatastorePoolDD " +
        "<libSrv> <userid> <pw>" );
       return;
      }
      else
      {
       libSrv = argv[0];
       userid = argv[1];
       pw = argv[2];
      } 
    try {
    DKDatastorePool dsrDD = new DKDatastorePool(fullClassName);
    dsrDD.setDatastoreName(libSrv);
    dsrDD.setMaxPoolSize(10);
    dsrDD.setMinPoolSize(3);

    dsrDD.initConnections(userid, pw, 2);
    dsrDD.setTimeOut(1); 
    System.out.println(" getMaxPoolSize =  " + dsrDD.getMaxPoolSize());
    System.out.println(" getMinPoolSize =  " + dsrDD.getMinPoolSize());
    System.out.println(" getTimeOut=  " + dsrDD.getTimeOut());

    dkDatastore dsDD1, dsDD2, dsDD3, dsDD4;
    dsDD1 = dsrDD.getConnection(userid, pw);             // new ds1
    System.out.println(" getConnection, dsDD1(ds1) =  " + dsDD1);
    dsDD2 = dsrDD.getConnection(userid, pw);             // new ds2
    System.out.println(" getConnection, dsDD2(ds2) =  " + dsDD2);

    DKDatastoreSession dsIdDD1, dsIdDD2, dsIdDD3, dsIdDD4;
    dsIdDD1 = dsrDD.getConnection(userid, pw, 0);        //new dsid1
    System.out.println(" getConnection, dsIdDD1(dsid1)=" +
     dsIdDD1.getDatastore() + ", sessionId=" + dsIdDD1.getId());
    dsIdDD2 = dsrDD.getConnection(userid, pw, 0);        //new dsid2
    System.out.println(" getConnection, dsIdDD2(dsid2)=" +
     dsIdDD2.getDatastore() + ", sessionId=" + dsIdDD2.getId()); 

    dsrDD.returnConnection(dsIdDD2);                     //dsid2 in _freeIdPool
    System.out.println(" returnConnection, dsIdDD2(dsid2) =  " + 
      dsIdDD2.getDatastore() + ", sessionId=" + dsIdDD2.getId());
    dsrDD.returnConnection(dsDD2);                       //ds2 in _freePool
    System.out.println(" returnConnection, dsDD2(ds2) =  " + dsDD2); 

    dsIdDD3 = dsrDD.getConnection(userid, pw, 1); //ds2 in _usedPool
    System.out.println(" getConnection, dsIdDD3(ds2)=" +
     dsIdDD3.getDatastore() + ", sessionId=" + dsIdDD3.getId());
    dsIdDD4 = dsrDD.getConnection(userid, pw, 5); //new dsid3  
    System.out.println(" getConnection, dsIdDD4(dsid3)=" +
     dsIdDD4.getDatastore() + ", sessionId=" + dsIdDD4.getId());


    dsIdDD4 = dsrDD.getConnection(userid, pw, 6); // new dsid4
    System.out.println(" getConnection, dsIdDD4(dsid4)=" +
     dsIdDD4.getDatastore() + ", sessionId=" + dsIdDD4.getId());

    dsDD1 = dsrDD.getConnection(userid, pw);  // new ds3
    System.out.println(" getConnection, dsDD1(ds3) =  " + dsDD1);
    dsDD2 = dsrDD.getConnection(userid, pw);  // new ds4
    System.out.println(" getConnection, dsDD2(ds4) =  " + dsDD2); 

    dsDD3 = dsrDD.getConnection(userid, pw);  // new ds5
    System.out.println(" getConnection, dsDD3(ds5) =  " + dsDD3);
    dsDD4 = dsrDD.getConnection(userid, pw);  // new ds6
    System.out.println(" getConnection, dsDD4(ds6) =  " + dsDD4); 


    dsIdDD3 = dsrDD.getConnection(userid, pw, 9); // dsid2 
    System.out.println(" getConnection, dsIdDD3(dsid2)=" +
     dsIdDD3.getDatastore() + ", sessionId=" + dsIdDD3.getId());


/** temp comment out due to hayward is not a upgraded level
    //**** use dsDD2 to list all subEntities
    System.out.println("||**** start: use dsDD2 to list all subEntities ****||");
       // get a list of rooms
       dkCollection rooms = dsDD2.listEntities();
       System.out.println("\n" + Me + ": Print rooms and their subEntities.");
       dkIterator itRooms = rooms.createIterator();
       itRooms.reset();
       while( itRooms.more() )
       { // print room titles and check for cabinets
         DKRoomDefDD aRoom = (DKRoomDefDD)itRooms.next();
         // check the room for cabinets
         System.out.println("Room: " + aRoom.getName() );
         if( aRoom.hasSubEntities() )
         {
           dkCollection cabinets = aRoom.listSubEntities();
           dkIterator itCabinets = cabinets.createIterator();
           while( itCabinets.more() )
           { // print cabinet titles and check for binders
             DKCabinetDefDD aCab = (DKCabinetDefDD)itCabinets.next();
             System.out.println("  Cabinet: " + aCab.getName() );

             if( aCab.hasSubEntities() )
             {
               dkCollection binders = aCab.listSubEntities();
               dkIterator itBinders = binders.createIterator();

               while( itBinders.more() )
               {
                 DKBinderDefDD aBinder = (DKBinderDefDD)itBinders.next();
                 System.out.println("    Binder: " + aBinder.getName() );

                 if( aBinder.hasSubEntities() )
                 {
                   dkCollection documents = aBinder.listSubEntities();
                   dkIterator itDocs = documents.createIterator();
                   itDocs.reset();

                   while( itDocs.more() )
                   { // print document titles
                     DKDocumentDefDD aDocument = (DKDocumentDefDD)itDocs.next();
                     System.out.println("      Document: " + aDocument.getName() );

                     // now, for extra credit, print the attributes of the document
                     DKAttrProfileDefDD profile = aDocument.getProfile();
                     dkCollection fields = profile.getFields();

                     if((fields != null) &&( fields.cardinality() > 0 ))
                     {
                       dkIterator itFields = fields.createIterator();
                       while( itFields.more() )
                       { // print name, keywords
                         DKAttrDefDD aField = (DKAttrDefDD)itFields.next();
                         System.out.println("        " + aField.getName() + ": " + aField.getValue() );
                         dkCollection keywords = ((DKAttrFieldDefDD)aField).getKeywords();
                         if( keywords != null )
                         {
                           if( keywords.cardinality() > 0 )
                           { // print name
                             dkIterator itKeywords = keywords.createIterator();
                             while( itKeywords.more() )
                             {
                               DKAttrDefDD aKeyword = (DKAttrDefDD)itKeywords.next();
                               System.out.println("          " + aKeyword.getName() + ": " + aKeyword.getValue() );
                             }
                           } // end keyword processing
                         }
                       } // end field processing
                     }
                   } // end document processing
                 }
               }  // end binder processing
             }
           } // end cabinet processing
         }
       } // end room processing
    System.out.println("||**** end: use dsDD2 to list all subEntities ****||");
    //****end of use dsDD2 to list all subEntities
**/

    dsrDD.returnConnection(dsDD2);
    System.out.println(" returnConnection, dsDD2(ds4) =  " + dsDD2);
    dsDD4 = dsrDD.getConnection(userid, pw);
    System.out.print(" getConnection, dsDD4 =  " + dsDD4); 
    System.out.println("    dsDD4 == dsDD2 =  " + (dsDD4 == dsDD2)); //true

    //**** you can add codes to use dsDD4 to do other thing here  
    //**** end of use dsDD4 to do other thing
       
    dsrDD.returnConnection(dsDD1);
    System.out.println(" returnConnection, dsDD1(ds3) =  " + dsDD1);
    dsrDD.returnConnection(dsDD3);
    System.out.println(" returnConnection, dsDD3(ds5) =  " + dsDD3);
    dsrDD.returnConnection(dsIdDD4); //dsid4 in _freeIdPool
    System.out.println(" returnConnection, dsIdDD4(dsid4) =  " + 
      dsIdDD4.getDatastore() + ", sessionId=" + dsIdDD4.getId());
     

    System.out.println("**** start sleep for 120050 mini sec*******");
    Thread.sleep(120050);  //the two in freePool will be disconnected
    System.out.println("**** end sleep for 120050 mini sec*******");

    dsDD2 = dsrDD.getConnection(userid, pw);     //new ds7
    System.out.println(" getConnection, dsDD2(ds7) =  " + dsDD2); 
    System.out.println(" call destroy()..." );
    dsrDD.destroy();  //take a while for all 4 in usedPool to be disconnected

    }
    catch (DKException exc)
    {
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }

  public static void processResults(dkCollection results) 
                throws DKException, Exception
  {
    Short    sVal;
    short    itemType = 0;
    DKDDO    item = null;
    short    i = 0;
    String   dataName;
    DKParts  parts = null;
    DKFolder folder = null;
    System.out.println( "number of items " + results.cardinality());
 
    dkIterator iter = results.createIterator();
 
    while(iter.more()) {
       item = (DKDDO) iter.next();
       if (item != null) {
   	  item.retrieve();
   	  sVal = (Short)item.getPropertyByName(DK_PROPERTY_ITEM_TYPE);
   	  itemType = sVal.shortValue();
   	  switch(itemType) {
   	    case DK_DOCUMENT:
   	      System.out.println(" Item is a document, number of data item : " + item.dataCount());
   	      for (i = 1; i <= item.dataCount(); i++) {
   		   dataName = item.getDataName(i);
   		   System.out.println("    data-item[" + i + "] = " + dataName + ", value " + item.getData(i));
   		   if (dataName.equals(DKPARTS) == true) {
   		       parts = (DKParts)item.getData(i);
   		       if (parts != null) 
			   System.out.println("   this document has " + parts.cardinality() + " parts ");
   		   }
   	      }
   	      break;
   	    case DK_FOLDER:
   	      System.out.println(" Item is a folder,    number of data item : " + item.dataCount());
   	      for (i = 1; i <= item.dataCount(); i++) {
   		  dataName = item.getDataName(i);
   		  System.out.println("    data-item[" + i + "] = " + dataName + ", value " + item.getData(i));
   		  if (dataName.equals(DKPARTS) == true) {
   		      parts = (DKParts)item.getData(i);
   		      if (parts != null) 
   			 System.out.println("   this folder has " + parts.cardinality() + " parts ");
   		  }
   		  if (dataName.equals(DKFOLDER) == true) {
   		      folder = (DKFolder)item.getData(i);
   		      System.out.println("   this folder has " + folder.cardinality() + " documents ");
   		  }  
   	      }
   	      if (folder != null && folder.cardinality() > 0) {
   		  System.out.println("     --------- list of folder contents --------  ");
   		  processResults(folder);
   		  System.out.println("     ----------- end of list ------------------ ");
   	      }
   	      else System.out.println("  empty folder ");
   	      break;
   	    case DK_WORKBASKET:
   	      System.out.println("  Item is a workbasket ");
   	      break;
   	    case DK_WORKFLOW:
   	      System.out.println("  Item is a workflow ");
   	      break;
   	    default:
   	      System.out.println("  Item is not recognized ");
   	      break;
   	  } 
       }
    } 
  }
}

