/* -------------------------------------------------------------------
 * @copyright(disclaimer) 
 * IBM Enterprise Information Portal for Multiplatforms V7.1  (program number 5697-G29) 
 * (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
 * IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03) 
 * (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved. 
 * 
 * US Government Users Restricted Rights 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.  Licensed Materials - Property of IBM 
 * 
 * DISCLAIMER OF WARRANTIES : 
 * 
 * Permission is granted to copy and modify this code, and to 
 * distribute modified versions provided that both the copyright 
 * notice and this permission notice appear in all copies and modified 
 * versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS 
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM 
 * WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE 
 * OF THE CODE.
 * 
 * @endCopyright
 */

/*
 * Description    : sample getOption/setOption for Information Catalog
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*; // using server package: 3-tier
import java.io.*;
import java.lang.*;

public class TOptionIC implements DKConstantIC
{
   // Main method
   public static void main(String argv[])
   {
      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);


      //*** for input parameters
      String db = new String(""),    // database
             userid = new String(""),    //userid
  	     pw = new String("");        // pw

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------
      if (argv.length < 3)
      {
         System.out.println("Usage: " );
         System.out.println( "  java TOptionIC "
                           + "<db> <userid> <pw> " );
         return;
      }
      else
      {
         db = argv[0];
         userid = argv[1];
         pw = argv[2];
      }

      try
      {
         DKDatastoreIC dsIC = new DKDatastoreIC();

         dsIC.connect( db, userid, pw, "" );           // connect to db
         System.out.println("--- datastore connected ---");

         Integer output = null, newOutput = null;
         Integer defaultValue = null;
         Integer newValue = new Integer(DK_CM_CONTENT_NO);

// get DK_CM_OPT_CONTENT
         defaultValue = new Integer(DK_CM_CONTENT_YES);
         output = (Integer)dsIC.getOption(DK_CM_OPT_CONTENT);


// set option to something else

         dsIC.setOption(DK_CM_OPT_CONTENT, newValue);


// get DK_CM_OPT_ACCESS_MODE

         defaultValue = new Integer(DK_CM_READONLY);
         output = (Integer)dsIC.getOption(DK_CM_OPT_ACCESS_MODE);

         dsIC.disconnect();                                        // disconnect from server
         System.out.println("--- datastore disconnected ---");
         dsIC.destroy();

      }
      catch (DKException exc)
      {
         System.out.println("Exception name " + exc.name());
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
         System.out.println("EXCEPTION FAILURE");
      }
      catch (Exception exc)
      {
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
         System.out.println("EXCEPTION FAILURE");
      }
   }
}
