/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

//*****************************************************************************
// File Name   = UtilPersistent.java
// Description = Utility to serialize/de-serialize a bean
// Author      = afic
// Date        = 03/26/1999
//
//*****************************************************************************

import java.io.*;

public class UtilPersistent {

    public UtilPersistent() {
    }

    public void save(Object theBean) {
        String prompt = "Please enter the file name with complete path:\n" + "Make sure the destination directory is writeable";
        String name = ui.getString(prompt);

        try {
            FileOutputStream f = new FileOutputStream(name);
            ObjectOutput s = new ObjectOutputStream(f);
            s.writeObject(theBean);
            s.flush();
            System.out.println("OK, the bean is save to: " + name);
            System.out.println("");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    public Object load() {
        String path = ui.getString("Enter the bean file with complete path:");

        try {
            FileInputStream f = new FileInputStream(path);
            ObjectInput s = new ObjectInputStream(f);
            Object o = s.readObject();
            System.out.println("OK, the bean is loaded from: " + path);
            System.out.println("");
            return o;
        } catch (Exception exc) {
            exc.printStackTrace();
            return null;
        }
    }

    UtilSimpleUI ui = new UtilSimpleUI();
}